#ifndef PROFILECHANGERWIDGET_H
#define PROFILECHANGERWIDGET_H

#include <QDBusInterface>
#include <qmaemo5homescreenadaptor.h>
#include <QErrorMessage>
#include "settingsdialog.h"
#include "syslog.h"

namespace Ui {
    class ProfileChangerWidget;
}

class ProfileChangerWidget : public QWidget
{
    Q_OBJECT

public:
    explicit ProfileChangerWidget(QWidget *parent = 0);
    ~ProfileChangerWidget();


public slots:
    void onShowSettingsDialog();
    void onChangeProfileClicked();
    void reloadSettings();

private:
    Ui::ProfileChangerWidget *ui;

private:
    QString getProfileName();
    void setProfile(QString profileName);
    void switchProfile();
    void showIconSilent();
    void showIconGeneral();
    void refreshIcon();
};

#endif // PROFILECHANGERWIDGET_H

